@echo off

:: Windows Script (Host) Uninstaller
::
:: Created by Eric L. Howes
::            eburger68@myrealbox.com
::            http://www.staff.uiuc.edu/~ehowes/
::
:: Copyright (c) 2000-2002 Eric L. Howes
::
:: This program is free software; you can redistribute it and/or modify it under
:: the terms of the GNU General Public License as published by the Free Software
:: Foundation; either version 2, or (at your option) any later version.
::
:: This program is distributed in the hope that it will be useful, but WITHOUT ANY
:: WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
:: A PARTICULAR PURPOSE.  See the GNU General Public License for more details.
::
:: Some files distributed with this package may not be covered by the GNU GPL. Those
:: files remain the property of their original owners and are covered by the licenses
:: under which they were originally distributed.
::
:: All trademarks are the property of their respective owners.
::
:: You should have received a copy of the GNU General Public License along with this
:: program; see the file COPYING.  If not, write to the Free Software Foundation,
:: 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.


cls

::********************************************************************
:CONFIRM
::********************************************************************

cls

:: --------------
:: Ask To Confirm
:: --------------

   echo       ***********************************************
   echo       *                                             *
   echo       *      Windows Script (Host) Uninstaller      *
   echo       *                                             *
   echo       ***********************************************
   echo. 
   echo.
   echo    This program will uninstall Windows Script (Host) from your PC.
   echo.
   echo    Do you want to uninstall Windows Script (Host)?
   echo. 
   echo       [1] YES - uninstall WSH
   echo       [2] NO  - exit this program
   echo.
   echo       (3) More INFO, Please!
   echo       (4) View the README.TXT

   choice /c:12345 /n /t:5,90

   if errorlevel 5 goto CONFIRM
   if errorlevel 4 goto README
   if errorlevel 3 goto INFO
   if errorlevel 2 goto FIN
   if errorlevel 1 goto UNINSTALL

::********************************************************************
:INFO
::********************************************************************

   cls

   echo.
   echo                        ** MORE INFO **
   echo. 
   echo.
   echo    This batch file utility will uninstall any version of Windows
   echo    Script, sometimes known as the Windows Scripting Host. It will
   echo    uninstall Windows Script (Host) no matter the original source
   echo    of the installation...
   echo.
   echo        * Windows Script 5.6 (from microsoft.com)
   echo        * Windows Script 5.5 (from microsoft.com)
   echo        * Windows Script 5.1 (from microsoft.com)
   echo        * Windows Script 5.0 (from microsoft.com)
   echo.
   echo        * Visual Basic Scripting Support (any version of IE 5)
   echo.
   echo        * Windows Scripting Host 2.0 beta
   echo        * Windows Scripting Host 1.0 (Windows 98 SE)
   echo        * Windows Scripting Host 1.0 (Windows 98)
   echo        * Windows Scripting Host 1.0
   echo.
   echo.
   pause
   cls
   echo.
   echo                   ** Versions of Windows  **
   echo. 
   echo.
   echo    This batch file can uninstall Windows Script (Host) from the
   echo    following versions of Windows...
   echo.
   echo        * Windows 98 SE
   echo        * Windows 98 (original or SR1)
   echo        * Windows 95 (any version)
   echo.
   echo        * Windows NT 4.0 (any service pack level)
   echo.
   echo    This batch file will NOT uninstall Windows Script (Host) from
   echo    Windows ME or Windows 2000 due to the System File Protection
   echo    scheme that these versions of Windows employ.
   echo.
   echo.
   pause
   cls
   echo.
   echo                      ** What Happens **
   echo. 
   echo.
   echo    Uninstallation of Windows Script (Host) involves the following actions...
   echo.
   echo        * unregistering DLL's and OCX's
   echo        * deleting files
   echo        * removing Extensions and Registered File Types
   echo        * cleaning up misc. Registry entries
   echo.
   echo    See the ReadMe.txt for more details about exactly what happens
   echo    during uninstallation of Windows Script (Host).
   echo.
   echo.
   pause
   cls
   echo.
   echo              ** To Reinstall Windows Script (Host)  **
   echo.
   echo.
   echo    If you later decide that you would like to reinstall Windows Script
   echo    (Host), you can download the latest version of Windows Script (Host)
   echo    from:
   echo.
   echo         http://msdn.microsoft.com/scripting/
   echo.
   echo.
   pause
   cls
   echo.
   echo                     ** To Learn More...  **
   echo. 
   echo.
   echo    For still more information, please see the ReadMe.txt which
   echo    accompanies this batch file.
   echo.
   echo.
   pause

   goto CONFIRM

::********************************************************************
:README
::********************************************************************

   cls

   :: --------------------
   :: Check for ReadMe.txt
   :: --------------------

   if not exist readme.txt goto NO-READ

   :: ------------------------------
   :: Open ReadMe.txt in notepad.exe
   :: ------------------------------

   notepad.exe readme.txt

   goto CONFIRM

::------
:NO-READ
::------

   echo.
   echo                      ** No ReadMe.txt **
   echo. 
   echo.
   echo    Sorry, could not find the ReadMe.txt for this program.
   echo.
   echo.   Please make sure that ReadMe.txt is in the same directory
   echo    as this batch file and try again.
   echo.
   echo.
   pause
   goto CONFIRM

::********************************************************************
:UNINSTALL
::********************************************************************

cls

:: -------------
:: Confirm Again
:: -------------

   echo.
   echo                     ** CONFIRM UNINSTALLATION **
   echo. 
   echo.
   echo    Are you sure that you want to uninstall Windows Script (Host)
   echo    from this PC?
   echo. 
   echo       [1] YES - uninstall WSH
   echo       [2] NO  - return to main menu

   choice /c:123 /n /t:3,90

   if errorlevel 3 goto CONFIRM
   if errorlevel 2 goto CONFIRM
   if errorlevel 1 goto PROCEED

::------
:PROCEED
::------

:: ----------------------------------------------------------------
:: Check for existence of WS(H) & see if we have Win9x or WinNT/2K,
:: then go to the appropriate section.
:: ----------------------------------------------------------------

   if exist %WINDIR%\wscript.exe goto 9X-UNINST
   if exist %WINDIR%\SYSTEM32\wscript.exe goto NT-UNINST 

   goto UN-ERR1

::********
:9X-UNINST
::********

   cls
   
   echo.
   echo    You have elected to uninstall Windows Script (Host)...
   echo.

:: ------------------------------------------------------------
:: Check if we are running Windows Me.
:: If so, then goto the appropriate error message.
:: ------------------------------------------------------------

   if exist %WINDIR%\system\sfp\Sfpdb.sfp goto UN-ERR2
   if exist %WINDIR%\system\sfp\Sfplog.txt goto UN-ERR2

:: --------------------------------------------------
:: Check to make sure all required files are in place
:: --------------------------------------------------

   if not exist un-ext.reg goto MISSING
   if not exist un-misc.reg goto MISSING
   if not exist un-wshom.reg goto MISSING
   if not exist win98-un.reg goto MISSING
   if not exist ws56-un.reg goto MISSING

:: ----------------------
:: UNREGISTER DLL'S/OCX'S
:: ----------------------

   echo.
   echo    Unregistering DLL's...
   echo.

   :: all versions

   %WINDIR%\SYSTEM\regsvr32.exe /u /s %WINDIR%\SYSTEM\scrrun.dll
   start /w regedit.exe /s un-wshom.reg
   %WINDIR%\SYSTEM\regsvr32.exe /u /s %WINDIR%\SYSTEM\wshext.dll

   :: WS 5.6 only

   if exist %WINDIR%\INF\scr56en.inf start /w regedit.exe /s ws56-un.reg

   :: disabled

:: %WINDIR%\SYSTEM\regsvr32.exe /u /s %WINDIR%\SYSTEM\dispex.dll
:: %WINDIR%\SYSTEM\regsvr32.exe /u /s %WINDIR%\SYSTEM\jscript.dll
:: %WINDIR%\SYSTEM\regsvr32.exe /u /s %WINDIR%\SYSTEM\scrobj.dll
:: %WINDIR%\SYSTEM\regsvr32.exe /u /s %WINDIR%\SYSTEM\vbscript.dll

:: ------------
:: DELETE FILES
:: ------------

   echo.
   echo    Deleting files...
   echo.

   :: all versions

   if exist %WINDIR%\COMMAND\cscript.exe del %WINDIR%\COMMAND\cscript.exe
   if exist %WINDIR%\SYSTEM\scrrun.dll del %WINDIR%\SYSTEM\scrrun.dll 
   if exist %WINDIR%\wscript.exe del %WINDIR%\wscript.exe 
   if exist %WINDIR%\SYSTEM\wshext.dll del %WINDIR%\SYSTEM\wshext.dll 
   if exist %WINDIR%\SYSTEM\wshom.ocx del %WINDIR%\SYSTEM\wshom.ocx 

   :: disabled

:: if exist %WINDIR%\SYSTEM\dispex.dll del %WINDIR%\SYSTEM\dispex.dll 
:: if exist %WINDIR%\SYSTEM\jscript.dll del %WINDIR%\SYSTEM\jscript.dll 
:: if exist %WINDIR%\SYSTEM\scrobj.dll del %WINDIR%\SYSTEM\scrobj.dll 
:: if exist %WINDIR%\SYSTEM\vbscript.dll del %WINDIR%\SYSTEM\vbscript.dll 

   :: help and inf files

   if exist %WINDIR%\HELP\wscript.hlp del %WINDIR%\HELP\wscript.hlp
   if exist %WINDIR%\HELP\wscript.gid del %WINDIR%\HELP\wscript.gid
   if exist %WINDIR%\HELP\wscript.cnt del %WINDIR%\HELP\wscript.cnt
   if exist %WINDIR%\INF\scr56en.inf del %WINDIR%\INF\scr56en.inf
   if exist %WINDIR%\INF\scr55en.inf del %WINDIR%\INF\scr55en.inf
   if exist %WINDIR%\INF\ste51en.inf del %WINDIR%\INF\ste51en.inf
   if exist %WINDIR%\INF\ste50en.inf del %WINDIR%\INF\ste50en.inf
   if exist %WINDIR%\INF\unie5bak.inf del %WINDIR%\INF\unie5bak.inf
   if exist %WINDIR%\INF\vbscript.inf del %WINDIR%\INF\vbscript.inf
   if exist %WINDIR%\INF\wsh20en.inf del %WINDIR%\INF\wsh20en.inf

   :: leave the next file because Win98 needs it for Setup Options
   :: (though WSH 1.0 also uses it)

:: if exist %WINDIR%\INF\wsh.inf del %WINDIR%\INF\wsh.inf

   :: samples

   if exist %WINDIR%\INF\wsh20en.inf del %WINDIR%\Samples\WSH\*.js
   if exist %WINDIR%\INF\wsh20en.inf del %WINDIR%\Samples\WSH\*.vbs
   if exist %WINDIR%\INF\wsh20en.inf del %WINDIR%\Samples\WSH\*.ws
   if exist %WINDIR%\INF\wsh20en.inf del %WINDIR%\Samples\WSH\*.xls
   if exist %WINDIR%\INF\wsh20en.inf rd %WINDIR%\Samples\WSH
   if exist %WINDIR%\INF\wsh20en.inf rd %WINDIR%\Samples

   if exist %WINDIR%\INF\wsh.inf del %WINDIR%\Samples\WSH\*.js
   if exist %WINDIR%\INF\wsh.inf del %WINDIR%\Samples\WSH\*.vbs
   if exist %WINDIR%\INF\wsh.inf del %WINDIR%\Samples\WSH\*.ws
   if exist %WINDIR%\INF\wsh.inf del %WINDIR%\Samples\WSH\*.xls
   if exist %WINDIR%\INF\wsh.inf rd %WINDIR%\Samples\WSH
   if exist %WINDIR%\INF\wsh.inf rd %WINDIR%\Samples

:: ----------------------------
:: REMOVE EXTENSIONS/FILE TYPES
:: ----------------------------

   echo.
   echo    Removing Extensions and File Types...
   echo.

   start /w regedit.exe /s un-ext.reg

:: -----------------------------------------------------
:: CLEANUP ACTIVE SETUP INFO, APPROVED SHELL EXT'S, ETC.
:: -----------------------------------------------------

   echo.
   echo    Cleaning up remaining Registry entries...
   echo.

   start /w regedit.exe /s un-misc.reg

:: ----------------------------------------------------------
:: Check if we have Win98 or 98SE. If so, toggle the Optional
:: Components Windows Setup option to "not installed." 
:: ----------------------------------------------------------

   start /w regedit.exe /e check.reg HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows\CurrentVersion\Setup\OptionalComponents
   if exist check.reg start /w regedit.exe /s win98-un.reg

   :: Clean up...

   del check.reg>nul

   goto SUCCESS

::********
:NT-UNINST
::********

   cls
   
   echo.
   echo    You have elected to uninstall Windows Script (Host)...
   echo.

:: ------------------------------------------------------------
:: Check if we are running Windows 2000.
:: If so, then goto the appropriate error message.
:: ------------------------------------------------------------

   if exist %WINDIR%\System32\Dllcache goto UN-ERR3
   if exist %WINDIR%\System32\rpcss.dll goto UN-ERR3

:: --------------------------------------------------
:: Check to make sure all required files are in place
:: --------------------------------------------------

   if not exist un-ext.reg goto MISSING
   if not exist un-misc.reg goto MISSING
   if not exist un-wshom.reg goto MISSING
   if not exist ws56-un.reg goto MISSING

:: ----------------------
:: UNREGISTER DLL'S/OCX'S
:: ----------------------

   echo.
   echo    Unregistering DLL's...
   echo.

   :: all versions

   %WINDIR%\SYSTEM32\regsvr32.exe /u /s %WINDIR%\SYSTEM32\scrrun.dll
   start /w regedit.exe /s un-wshom.reg
   %WINDIR%\SYSTEM32\regsvr32.exe /u /s %WINDIR%\SYSTEM32\wshext.dll

   :: NT 4.0, WS 5.6 only

   %WINDIR%\SYSTEM32\regsvr32.exe /u /s %WINDIR%\SYSTEM32\wshcon.dll

   :: WS 5.6 only

   if exist %WINDIR%\INF\scr56en.inf start /w regedit.exe /s ws56-un.reg

   :: disabled

:: %WINDIR%\SYSTEM32\regsvr32.exe /u /s %WINDIR%\SYSTEM32\dispex.dll
:: %WINDIR%\SYSTEM32\regsvr32.exe /u /s %WINDIR%\SYSTEM32\jscript.dll
:: %WINDIR%\SYSTEM32\regsvr32.exe /u /s %WINDIR%\SYSTEM32\scrobj.dll
:: %WINDIR%\SYSTEM32\regsvr32.exe /u /s %WINDIR%\SYSTEM32\vbscript.dll

:: ------------
:: DELETE FILES
:: ------------

   echo.
   echo    Deleting files...
   echo.

   :: all versions

   if exist %WINDIR%\SYSTEM32\cscript.exe del %WINDIR%\SYSTEM32\cscript.exe
   if exist %WINDIR%\SYSTEM32\scrrun.dll del %WINDIR%\SYSTEM32\scrrun.dll 
   if exist %WINDIR%\SYSTEM32\wscript.exe del %WINDIR%\SYSTEM32\wscript.exe 
   if exist %WINDIR%\SYSTEM32\wshext.dll del %WINDIR%\SYSTEM32\wshext.dll 
   if exist %WINDIR%\SYSTEM32\wshom.ocx del %WINDIR%\SYSTEM32\wshom.ocx 

   :: NT 4.0, WS 5.6 only

   if exist %WINDIR%\SYSTEM32\wshcon.dll del %WINDIR%\SYSTEM32\wshcon.dll

   :: disabled

:: if exist %WINDIR%\SYSTEM32\dispex.dll del %WINDIR%\SYSTEM32\dispex.dll 
:: if exist %WINDIR%\SYSTEM32\jscript.dll del %WINDIR%\SYSTEM32\jscript.dll 
:: if exist %WINDIR%\SYSTEM32\scrobj.dll del %WINDIR%\SYSTEM32\scrobj.dll 
:: if exist %WINDIR%\SYSTEM32\vbscript.dll del %WINDIR%\SYSTEM32\vbscript.dll 

   :: help and inf files

   if exist %WINDIR%\HELP\wscript.hlp del %WINDIR%\HELP\wscript.hlp
   if exist %WINDIR%\HELP\wscript.gid del %WINDIR%\HELP\wscript.gid
   if exist %WINDIR%\HELP\wscript.cnt del %WINDIR%\HELP\wscript.cnt
   if exist %WINDIR%\INF\scr56en.inf del %WINDIR%\INF\scr56en.inf
   if exist %WINDIR%\INF\scr55en.inf del %WINDIR%\INF\scr55en.inf
   if exist %WINDIR%\INF\ste51en.inf del %WINDIR%\INF\ste51en.inf
   if exist %WINDIR%\INF\ste50en.inf del %WINDIR%\INF\ste50en.inf
   if exist %WINDIR%\INF\unie5bak.inf del %WINDIR%\INF\unie5bak.inf
   if exist %WINDIR%\INF\vbscript.inf del %WINDIR%\INF\vbscript.inf
   if exist %WINDIR%\INF\wsh.inf del %WINDIR%\INF\wsh.inf
   if exist %WINDIR%\INF\wsh20en.inf del %WINDIR%\INF\wsh20en.inf

   :: samples

   if exist %WINDIR%\INF\wsh20en.inf del %WINDIR%\Samples\WSH\*.js
   if exist %WINDIR%\INF\wsh20en.inf del %WINDIR%\Samples\WSH\*.vbs
   if exist %WINDIR%\INF\wsh20en.inf del %WINDIR%\Samples\WSH\*.ws
   if exist %WINDIR%\INF\wsh20en.inf del %WINDIR%\Samples\WSH\*.xls
   if exist %WINDIR%\INF\wsh20en.inf rd %WINDIR%\Samples\WSH
   if exist %WINDIR%\INF\wsh20en.inf rd %WINDIR%\Samples

   if exist %WINDIR%\INF\wsh.inf del %WINDIR%\Samples\WSH\*.js
   if exist %WINDIR%\INF\wsh.inf del %WINDIR%\Samples\WSH\*.vbs
   if exist %WINDIR%\INF\wsh.inf del %WINDIR%\Samples\WSH\*.ws
   if exist %WINDIR%\INF\wsh.inf del %WINDIR%\Samples\WSH\*.xls
   if exist %WINDIR%\INF\wsh.inf rd %WINDIR%\Samples\WSH
   if exist %WINDIR%\INF\wsh.inf rd %WINDIR%\Samples

:: ----------------------------
:: REMOVE EXTENSIONS/FILE TYPES
:: ----------------------------

   echo.
   echo    Removing Extensions and File Types...
   echo.

   start /w regedit.exe /s un-ext.reg

:: -----------------------------------------------------
:: CLEANUP ACTIVE SETUP INFO, APPROVED SHELL EXT'S, ETC.
:: -----------------------------------------------------

   echo.
   echo    Cleaning up remaining Registry entries...
   echo.

   start /w regedit.exe /s un-misc.reg

   goto SUCCESS

::******
:UN-ERR1
::******

   cls

   echo.
   echo                ** Windows Script (Host) Not Installed **
   echo.
   echo.
   echo    It doesn't appear that Windows Script (Host) is installed on this
   echo    computer, thus Windows Script (Host) cannot be uninstalled.
   echo.
   goto CIAO

::******
:UN-ERR2
::******

   cls

   echo.
   echo                      ** Not For Windows ME **
   echo.
   echo.
   echo    ... but it appears that you are running Windows Me. This program
   echo    will not work on Windows Me due to the System File Protection
   echo    scheme of Windows Me. 
   echo.
   goto PROBLEM

::******
:UN-ERR3
::******

   cls

   echo.
   echo                     ** Not For Windows 2000 **
   echo.
   echo.
   echo    ... but it appears that you are running Windows 2000. This program
   echo    will not work on Windows 2000 due to the System File Protection
   echo    scheme of Windows 2000. 
   echo.
   goto PROBLEM

::******
:MISSING
::******

   cls

   echo.
   echo                     ** Required Files Missing **
   echo.
   echo.
   echo    ... but it appears that one of the following files required for
   echo    this program is missing:
   echo.
   echo         un-ext.reg
   echo         un-misc.reg
   echo         un-wshom.reg
   echo         win98-un.reg
   echo         ws56-un.reg
   echo.
   echo    Please make sure that all of the above files are in the same 
   echo    directory as this batch file, then run this program again.
   echo.
   goto PROBLEM

::******
:PROBLEM
::******

  echo.
  echo    Windows Script (Host) could not be uninstalled from this computer.
  echo.
  goto CIAO

::********************************************************************
:SUCCESS
::********************************************************************

   cls

   echo.
   echo                      ** SUCCESS! **
   echo.
   echo.
   echo    Windows Script (Host) was uninstalled successfully!
   echo.
   goto CIAO

::********************************************************************
:FIN
::********************************************************************

   cls

::---
:CIAO
::---

   echo.
   echo    Bye for now...
   echo.
   echo.

